(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(["exports", "fs", "rxjs", "rxjs/operators"], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require("fs"), require("rxjs"), require("rxjs/operators"));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.fs, global.rxjs, global.operators);
    global.appendFile = mod.exports;
  }
})(typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : this, function (_exports, _fs, _rxjs, _operators) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.default = void 0;

  const appendFile = function appendFile({
    filePath,
    options = {},
    _appendFile = (0, _rxjs.bindNodeCallback)(_fs.appendFile)
  }) {
    return data$ => data$.pipe((0, _operators.mergeMap)(data => _appendFile(filePath, data, options)));
  };

  var _default = appendFile;
  _exports.default = _default;
});
//# sourceMappingURL=appendFile.js.map