(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(["exports", "rxjs"], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require("rxjs"));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.rxjs);
    global.completeUpload = mod.exports;
  }
})(typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : this, function (_exports, _rxjs) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.default = void 0;

  const completeUpload = function completeUpload({
    s3Bucket,
    s3Key,
    uploadId,
    parts,
    s3
  }) {
    const s3Opts = {
      Bucket: s3Bucket,
      Key: s3Key,
      UploadId: uploadId,
      MultipartUpload: {
        Parts: parts
      }
    };
    const response$ = (0, _rxjs.from)(s3.completeMultipartUpload(s3Opts).promise());
    return response$;
  };

  var _default = completeUpload;
  _exports.default = _default;
});
//# sourceMappingURL=completeUpload.js.map