(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(["exports", "rxjs"], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require("rxjs"));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.rxjs);
    global.uploadPart = mod.exports;
  }
})(typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : this, function (_exports, _rxjs) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.default = void 0;

  const uploadPart = function uploadPart({
    partBuffer,
    partNumber,
    s3Bucket,
    s3Key,
    uploadId,
    s3
  }) {
    const uploadOpts = {
      Body: partBuffer,
      Bucket: s3Bucket,
      Key: s3Key,
      PartNumber: partNumber,
      UploadId: uploadId
    };
    const response$ = (0, _rxjs.from)(s3.uploadPart(uploadOpts).promise());
    return response$;
  };

  var _default = uploadPart;
  _exports.default = _default;
});
//# sourceMappingURL=uploadPart.js.map