[![CircleCI](https://circleci.com/gh/buccaneerai/bottlenose/tree/master.svg?style=shield)](https://circleci.com/gh/buccaneerai/bottlenose/tree/master)
[![License: MIT](https://img.shields.io/badge/License-MIT-green.svg)](https://opensource.org/licenses/MIT)
<a href="https://www.npmjs.com/package/@bottlenose/rxstats">
  <img src="https://img.shields.io/npm/v/@bottlenose/rxstats.svg" alt="Version">
</a>

## Description
This module is part of the [Bottlenose project](https://github.com/buccaneerai/bottlenose), which is a larger effort to create second-to-none data science tools for software makers who love JavaScript.

`@bottlenose/rxsgd` provides a set of of [RxJS](http://rxjs.dev/) operators to train SGD (Stochastic Gradient Descent) classifiers.

## Installation

### npm

```bash
npm i @bottlenose/rxsgd --save
```

### yarn

```bash
yarn add @bottlenose/rxsgd
```

### Compatability

| Platform | Support |
| :--- | :--- |
| node.js \(&gt;10.0\) | ✅ |
| Browsers | ✅ |
| React Native | ✅ |
| Electron | ✅ |

# Documentation & Guides
- [Documentation](https://buccaneerai.gitbook.io/bottlenose/data-analysis/rxstats)
- [Getting Started](https://buccaneerai.gitbook.io/bottlenose/data-analysis/rxstats/guides/gettingstarted)
- [Full list of operators](https://buccaneerai.gitbook.io/bottlenose/data-analysis/rxstats/operators)
- [Guides](https://buccaneerai.gitbook.io/bottlenose/data-analysis/rxstats/guides)
