(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(["exports"], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports);
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports);
    global.predictValue = mod.exports;
  }
})(typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : this, function (_exports) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.default = void 0;

  const predictValue = function predictValue({
    row,
    intercept,
    weights
  }) {
    const predictedValue = weights.reduce((memo, weight, i) => memo + weight * row[i], intercept);
    return 1.0 / (1.0 + Math.E ** -predictedValue);
  };

  var _default = predictValue;
  _exports.default = _default;
});
//# sourceMappingURL=predictValue.js.map