(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(["exports", "./accuracy", "./change", "./countValues", "./dirtyR", "./dirtyZScore", "./f1", "./mean", "./precision", "./recall", "./roundTo", "./stdev", "./sum", "./throwUnlessNum", "./variance"], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require("./accuracy"), require("./change"), require("./countValues"), require("./dirtyR"), require("./dirtyZScore"), require("./f1"), require("./mean"), require("./precision"), require("./recall"), require("./roundTo"), require("./stdev"), require("./sum"), require("./throwUnlessNum"), require("./variance"));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.accuracy, global.change, global.countValues, global.dirtyR, global.dirtyZScore, global.f1, global.mean, global.precision, global.recall, global.roundTo, global.stdev, global.sum, global.throwUnlessNum, global.variance);
    global.index = mod.exports;
  }
})(typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : this, function (_exports, _accuracy, _change, _countValues, _dirtyR, _dirtyZScore, _f, _mean, _precision, _recall, _roundTo, _stdev, _sum, _throwUnlessNum, _variance) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  Object.defineProperty(_exports, "accuracy", {
    enumerable: true,
    get: function () {
      return _accuracy.default;
    }
  });
  Object.defineProperty(_exports, "change", {
    enumerable: true,
    get: function () {
      return _change.default;
    }
  });
  Object.defineProperty(_exports, "countValues", {
    enumerable: true,
    get: function () {
      return _countValues.default;
    }
  });
  Object.defineProperty(_exports, "dirtyR", {
    enumerable: true,
    get: function () {
      return _dirtyR.default;
    }
  });
  Object.defineProperty(_exports, "dirtyZScore", {
    enumerable: true,
    get: function () {
      return _dirtyZScore.default;
    }
  });
  Object.defineProperty(_exports, "f1", {
    enumerable: true,
    get: function () {
      return _f.default;
    }
  });
  Object.defineProperty(_exports, "mean", {
    enumerable: true,
    get: function () {
      return _mean.default;
    }
  });
  Object.defineProperty(_exports, "precision", {
    enumerable: true,
    get: function () {
      return _precision.default;
    }
  });
  Object.defineProperty(_exports, "recall", {
    enumerable: true,
    get: function () {
      return _recall.default;
    }
  });
  Object.defineProperty(_exports, "roundTo", {
    enumerable: true,
    get: function () {
      return _roundTo.default;
    }
  });
  Object.defineProperty(_exports, "stdev", {
    enumerable: true,
    get: function () {
      return _stdev.default;
    }
  });
  Object.defineProperty(_exports, "sum", {
    enumerable: true,
    get: function () {
      return _sum.default;
    }
  });
  Object.defineProperty(_exports, "throwUnlessNum", {
    enumerable: true,
    get: function () {
      return _throwUnlessNum.default;
    }
  });
  Object.defineProperty(_exports, "variance", {
    enumerable: true,
    get: function () {
      return _variance.default;
    }
  });
  _accuracy = _interopRequireDefault(_accuracy);
  _change = _interopRequireDefault(_change);
  _countValues = _interopRequireDefault(_countValues);
  _dirtyR = _interopRequireDefault(_dirtyR);
  _dirtyZScore = _interopRequireDefault(_dirtyZScore);
  _f = _interopRequireDefault(_f);
  _mean = _interopRequireDefault(_mean);
  _precision = _interopRequireDefault(_precision);
  _recall = _interopRequireDefault(_recall);
  _roundTo = _interopRequireDefault(_roundTo);
  _stdev = _interopRequireDefault(_stdev);
  _sum = _interopRequireDefault(_sum);
  _throwUnlessNum = _interopRequireDefault(_throwUnlessNum);
  _variance = _interopRequireDefault(_variance);

  function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
});
//# sourceMappingURL=index.js.map