(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(["exports", "./send", "./client", "./conduit", "./connections", "./consume", "./disconnections"], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require("./send"), require("./client"), require("./conduit"), require("./connections"), require("./consume"), require("./disconnections"));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.send, global.client, global.conduit, global.connections, global.consume, global.disconnections);
    global.index = mod.exports;
  }
})(typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : this, function (_exports, _send, _client, _conduit, _connections, _consume, _disconnections) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  Object.defineProperty(_exports, "send", {
    enumerable: true,
    get: function () {
      return _send.default;
    }
  });
  Object.defineProperty(_exports, "client", {
    enumerable: true,
    get: function () {
      return _client.default;
    }
  });
  Object.defineProperty(_exports, "conduit", {
    enumerable: true,
    get: function () {
      return _conduit.default;
    }
  });
  Object.defineProperty(_exports, "connections", {
    enumerable: true,
    get: function () {
      return _connections.default;
    }
  });
  Object.defineProperty(_exports, "consume", {
    enumerable: true,
    get: function () {
      return _consume.default;
    }
  });
  Object.defineProperty(_exports, "disconnections", {
    enumerable: true,
    get: function () {
      return _disconnections.default;
    }
  });
  _send = _interopRequireDefault(_send);
  _client = _interopRequireDefault(_client);
  _conduit = _interopRequireDefault(_conduit);
  _connections = _interopRequireDefault(_connections);
  _consume = _interopRequireDefault(_consume);
  _disconnections = _interopRequireDefault(_disconnections);

  function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
});
//# sourceMappingURL=index.js.map